# Requires
watchr = require("#{__dirname}/../lib/watchr.coffee")
assert = require('assert')
balUtil = require('bal-util')
path = require('path')
fs = require('fs')

# =====================================
# Configuration

# Config
debug = false

# Test Data
srcPath = path.join(__dirname,'src')
writetree =
	'a': 'a content'
	'b':
		'b-a': 'b-a content'
		'b-b': 'b-b content'
	'.c':
		'c-a': 'c-a content'


# =====================================
# Tests

# -------------------------------------
# Watchr

describe 'watchr', ->
	it 'should work as expected', (done) ->
		# Prepare
		@timeout(60*1000)

		# Prepare
		totalTasks = 12
		doneTasks = 0

		# Prepare
		complete = ->
			console.log "#{doneTasks} changes ran out of #{totalTasks} changes"  if debug
			assert.equal doneTasks, totalTasks
			done()

		# Timeout
		setTimeout(complete,55*1000)

		# Prepare handlers
		changeHappened = (args...) ->
			debugger
			console.log 'a change happened:', doneTasks+1,':', args  if debug
			++doneTasks

		# Change a file
		writeFile = (fileRelativePath) ->
			fileFullPath = path.join(srcPath,fileRelativePath)
			fs.writeFileSync(fileFullPath, "#{fileRelativePath} now has the random number #{Math.random()}")
		deleteFile = (fileRelativePath) ->
			fileFullPath = path.join(srcPath,fileRelativePath)
			fs.unlinkSync(fileFullPath)
		makeDir = (fileRelativePath) ->
			fileFullPath = path.join(srcPath,fileRelativePath)
			fs.mkdirSync(fileFullPath,'700')
		moveFile = (fileRelativePath1,fileRelativePath2) ->
			fileFullPath1 = path.join(srcPath,fileRelativePath1)
			fileFullPath2 = path.join(srcPath,fileRelativePath2)
			# do something...
		wait = (delay,fn) ->
			setTimeout(fn,delay)

		# Remove test dir
		balUtil.rmdir srcPath, (err) ->
			throw err  if err

			# Write test files
			balUtil.writetree srcPath, writetree, (err) ->
				throw err  if err

				# Start watching
				watchr.watch srcPath, changeHappened, (err,watcher) ->
					throw err  if err

					# Tests
					wait 5000, ->
						writeFile('a')
						writeFile('b/b-a')
						writeFile('.c/c-a')
						deleteFile('b/b-b')

						wait 5000, ->
							writeFile('someNewfile1')
							writeFile('someNewfile2')
							writeFile('someNewfile3')

							makeDir('someNewDir1')
							makeDir('someNewDir2')

							wait 5000, ->
								writeFile('someNewDir1/someNewfile1')
								writeFile('someNewDir1/someNewfile2')

								wait 5000, ->
									deleteFile('someNewDir1/someNewfile2')
